%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Written by Justin Legleiter %
% For Use in:                 %
% 09-723 Proximal Probe Tech  %
% (c)2004                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This code makes use of:
% Painless MATLAB GUIs for everybody
% (c) 2003, University of Cambridge
% Stefan Bleeck (stefan@bleeck.de)
% http://www.mrc-cbu.cam.ac.uk/cnbh/aimmanual/tools/parameter
% $Date: 2004/07/26$


function DHO_GUI_pow(params)
global Kspring; global Bdamp; global Mtip;global Ncycles; global PtsPerCycle;
global Zstart; global Zprime; global Finitial; global Fres; global Phi
global Skippy; global Fres; global SimStep; global Nsteps; global SimTime;
global Npts; global PointMat;global Foper; global Fo; global NginPT; 
global Ztraj; global dummy;global Bpower;global Penergy; global Tenergy;
global Kenergy; global Dpower;global time; global Denergy;global Benergy;



%global ModParams
% check the number of inputs
if nargin==0 % initial call without parameters.
params=parameter('Driven Harmonic Oscillator'); % create an object of the parameter class with name
    % now we add some items to it:
params=add(params,'float','Kspring',unit_none,10)%textbox for entering Kspring
params=add(params,'float','Bdamp',unit_none,0.1)%textbox for entering Bdamp
params=add(params,'float','Mtip',unit_none,1)%textbox for entering Mtip
params=add(params,'float','Ncycles',unit_none,100)%textbox for entering Ncycles
params=add(params,'float','PtsPerCycle',unit_none,64)%textbox for entering PtsPerCycle
params=add(params,'float','Zstart',unit_none,0)%textbox for entering Zstart
params=add(params,'float','Zprime',unit_none,0)%textbox for entering Zprime
params=add(params,'float','Fo',unit_none,10)%textbox for entering Fo
params=add(params,'float','Foper (Hz)',unit_none,0.5033)%textbox for entering Foper
params=add(params,'float','Phi (rad)',unit_none,0)%textbox for entering Phi
params=add(params,'button','Run Sim','DHO_GUI_pow(params)')%Button to export parameters
params=add(params,'button','Take Points','TakeTrajPoints2')%Button to export parameters
params=add(params,'button','FFT analysis','AnalyzeFFT')%Button to export parameters

    parametergui(params); % create the gui
    return  % and return to the shell. From now on the gui has the control 
end

% if we are here then we are called from the gui with the parameter
% structure in "params"

%creating paramter 
Kspring=get(params,'Kspring');
Bdamp=get(params,'Bdamp');
Mtip=get(params,'Mtip');
Ncycles=get(params,'Ncycles');
PtsPerCycle=get(params,'PtsPerCycle');
Zstart=get(params,'Zstart');
Zprime=get(params,'Zprime');
Fo=get(params,'Fo');
Foper=get(params,'Foper (Hz)');
Phi=get(params,'Phi (rad)');
skippy= 1;
%calculating parameters
dummy=((Kspring/Mtip)^0.5)/(2*pi);
if Fo==0
    SimStep = (1 / dummy) / PtsPerCycle;
else
SimStep = (1 / Foper) / PtsPerCycle;
end
Nsteps=(Ncycles-1)*PtsPerCycle;
SimTime=Nsteps*SimStep;
Npts = Nsteps + 1;
%run simulation
sim('PowerEnergyModel')%calling model
clear Traj;
%plotting results
Traj(1,:)=time';
Traj(2,:)=Ztraj';
Tenergy=Penergy+Kenergy;
figure (1)
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Trajectory - Hero for Hire Inc.');
plot(Traj(1,:),Traj(2,:));
%axis([0 SimTime -abs(Zstart)-1e-9 abs(Zstart)+1e-9])
xlabel 'time (s)'
ylabel 'z (m)'
set(gcf,'Color', [1 1 1]);
figure (3)
%subplot(2,1,1)
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Bpower/Dpower. - Hero for Hire Inc.');
plot(Traj(1,:)',Bpower,'r',Traj(1,:)',Dpower,'b')
xlabel 'time (s)'
legend ('Bpower','Dpower');
set(gcf,'Color', [1 1 1]);
ylabel 'Power'


figure (4)
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Energy - Hero for Hire Inc.');
set(gcf,'Color', [1 1 1]);
subplot(3,1,1)
plot(Traj(1,:)',Penergy)
ylabel 'P energy'
subplot(3,1,2)
plot(Traj(1,:)',Kenergy)
ylabel 'K energy'
subplot(3,1,3)
plot(Traj(1,:)',Tenergy)
ylabel 'T energy'
xlabel 'time (s)'

